from turtle import *
import Tkinter
import numpy as np
import random

#### parameters of process
mmin = 0.5
mmax = 1.5

speed(5)

####### parameters of visualization
# nsteps is number of attempts; scale is scaling within window; coords give initial 
# offset to near top left
# npeople is number in queue simulated
npeople = 70  
hscale = 26
vscale = 18
coords=np.zeros([npeople,2,npeople])
coords[0,0,0] = -350
coords[0,1,0] = -260


###### start initialization loop
penup()
goto(coords[0,0,0],coords[0,1,0])
pendown()
dot(8)
istep = 1
while istep < npeople:
	penup()
	coords[0,0,istep] = coords[0,0,istep -1] +  hscale*(mmin + (mmax - mmin)*random.random())
	coords[0,1,istep] = coords[0,1,0] 
	goto (coords[0,0,istep],coords[0,1,istep])
	pendown()
	dot(8)
	istep = istep + 1
	
#### start general loop
iserve = 1
while iserve < 35:
	wave = 0
	coords[iserve,0,0] = coords[0,0,0]
	coords[iserve,1,0] = coords[0,1,0] + vscale*iserve
	istep = 1
	while istep < npeople - iserve:
		penup()	
		if wave == 1:
			coords[iserve,0,istep] = coords[iserve -1,0,istep + 1]
		elif coords[iserve-1,0,istep +1 ] - coords[iserve,0,istep -1] < hscale*mmax:
			coords[iserve,0,istep] = coords[iserve -1,0,istep + 1]	
			wave = 1
		else:
			coords[iserve,0,istep] = coords[iserve,0,istep -1] + hscale*(mmin + (mmax - mmin)*random.random())
#		 	print coords[iserve,0,istep] 
		coords[iserve,1,istep] = coords[0,1,0]	+ vscale*iserve
		goto (coords[iserve-1,0,istep ],coords[iserve-1,1,istep ])	
		pendown()	
		goto (coords[iserve,0,istep -1], coords[iserve,1,istep -1] )
		dot(8)
		penup()	
		istep = istep + 1	
	iserve = iserve +1		
					
######
Tkinter.mainloop()
